/* LELUYA - GOROSTAS program block */
/* prototypes of functions which are dealing with the dust temperature */

#ifndef _GOROSTAS_prototypes_
#define _GOROSTAS_prototypes_

#include <stdio.h>
#include <math.h>
#include "../_global_structures.h"
#include "../_install_parameters.h"
#include "../_global_extern_variables.h"
#include "../MATH_LIB/nrutil.h"
#include "../MATH_LIB/MATH_LIB.h"
#include "../PESJANEK/PESJANEK.h"
#include "../ZELENJAK/ZELENJAK.h"
#include "../VODENJAK/VODENJAK.h"

double _GOROSTAS_Find_Temperature (double x, double z, double T1, double T2, 
                                 int dust_component, double *U, int *err);
double _GOROSTAS_Equilibrium (double T, double x, double z, int dust_component,
                            double Function2);

void _GOROSTAS_create_integral_directions 
                                    (struct _vertex_structure *central_vertex);
/* create 3D cloud of points */
int _GOROSTAS_create_3D_cloud ();/* part of _GOROSTAS_create_integral_directions */
/* destroy 3D cloud of points */
int _GOROSTAS_destroy_3D_cloud ();/* part of _GOROSTAS_create_integral_directions */

int _GOROSTAS_Find_Psi (void);

int _GOROSTAS_Find_Temperature_Bins (void);

int _GOROSTAS_Find_Radial_Bins (void);

int _GOROSTAS_Intensity_Around_Point (double point_x, double point_z);

int _GOROSTAS_Radiation_Pressure (void);

void _GOROSTAS_set_logarithmic_density_at_pixels (int grid_flag) ;

void _GOROSTAS_update_density (void);
#endif
