
#ifndef _MATH_LIB_
#define _MATH_LIB_

#include <math.h>
#include <stdio.h>
#include <time.h> 

#include "nrutil.h"
#include "numrec.h"
#include "../GOROSTAS/GOROSTAS.h"
#include "../_install_parameters.h"
#include "../_global_structures.h"
#include "../_global_extern_variables.h"

int _MATH_LIB_linear_interpolation(double x1, double y1, double x2, double y2,
                              double x, double *y);

int _MATH_LIB_log_interpolation(double x1, double y1, double x2, double y2,
                           double x, double *y);

double _MATH_LIB_simpson(int N, int N1, int N2, double *x, double *y);

double _MATH_LIB_Planck (double T, double lambda);

double _MATH_LIB_Ridder_Root(
                   double (*equilibrium)(double, double, double, int, double),
                   double x, double z, int dust_component, double Function2,
                   double T1, double T2, double T_acc, int *err);

double _MATH_LIB_distance (double x1, double y1, double x2, double y2);

int _MATH_LIB_intersecting_lines(double Ax,double Ay,double Bx,double By,
                             double Cx,double Cy,double Dx,double Dy);

double _MATH_LIB_nu_value (double x0,double y0,double x1,double y1,
                           double x2,double y2) ;

double _MATH_LIB_plane_interpolation (double x1, double y1, double z1,
				      double x2, double y2, double z2,
				      double x3, double y3, double z3,
				      double x , double y);

double _MATH_LIB_plane_interpolation_logZ (double x1, double y1, double z1,
                                      double x2, double y2, double z2,
                                      double x3, double y3, double z3,
                                      double x , double y);

struct _3DVector _MATH_LIB_3D_vector_product (struct _3DVector v1, 
                                              struct _3DVector v2) ;

double _MATH_LIB_3Ddistance (struct _3DVector p1, struct _3DVector p2);

void _MATH_LIB_ludcmp_parallel(double **a, int n, int *indx, double *d);

double _MATH_LIB_distance_point_to_line (struct _vertex_structure *v0,
                                         struct _vertex_structure *v1,
                                         struct _vertex_structure *v2);

struct _3DVector _MATH_LIB_unit_vector(struct _3DVector p1, struct _3DVector p2);

#endif
