/* LELUYA - MATH_LIB program block */

/* the nu-value of the angle between two lines  */

#include "MATH_LIB.h"

double _MATH_LIB_nu_value (double x0,double y0,double x1,double y1,
                           double x2,double y2) {

  /* the lines are defined as (x0,y0)-(x1,y1) and (x0,y0)-(x2,y2)

                         (x2,y2)
                           /
                    line2 /  angle alpha
                         /  
                      (x0,y0)---------(x1,y1)
                              line1

     definition of the nu-value:
           
     if (0<=alpha<PI)   nu=cos(aplha)+1
     if (PI<=alpha<2PI) nu=-cos(alpha)-1
  */

  double line1x,line1y,line2x,line2y, length1,length2, nu;

  line1x = x1 - x0;
  line1y = y1 - y0;
  line2x = x2 - x0;
  line2y = y2 - y0;

  length1 = sqrt(line1x*line1x + line1y*line1y);
  if (length1 == 0.0) return 0.0; 
  length2 = sqrt(line2x*line2x + line2y*line2y);
  if (length2 == 0.0) return 0.0;
  line1x /= length1;
  line1y /= length1;
  line2x /= length2;
  line2y /= length2;

  nu = line1x*line2x + line1y*line2y;
  /*nu = nu/(length1*length2);*/

  /*if (line1x*line2y - line1y*line2x >= -1.0E-12) nu = nu +1.0;*/
  if (line1x*line2y - line1y*line2x >= 0.0) nu = nu +1.0;
  else nu = - nu - 1.0;

  return nu;
}
