/* LELUYA - MATH_LIB program block */
/* integral Int(y(x)dx) with the Simpson (trapezoid) approximation */

#include "MATH_LIB.h"

double _MATH_LIB_simpson(int N, int N1, int N2, double *x, double *y){
  /* N      = total number of the grid points: x[0..N-1], y[0..N-1]
     N1, N2 = lower and upper integration boundary
     y      = function for the integration
     x      = variable of the integration */
  int counter;     /* a counter of the grid points during the integration */
  double weight;   /* a weight factor during the integration steps */
  double integral; /* the result of integration */

  if (N1<0 || N1>=N || N2<0 || N2>=N || N2<N1) return 0.0;
  else {
    integral = 0.0;
    for (counter=N1; counter<=N2; counter++) {
      if (counter==N1)      weight = 0.5*(x[N1+1]-x[N1]);
      else if (counter==N2) weight = 0.5*(x[N2]-x[N2-1]);
      else weight = 0.5*(x[counter+1] - x[counter-1]);
      integral += (weight*y[counter]);
    }
    return integral;
  }
}
