#ifndef _NR_H_
#define _NR_H_



#ifndef _FCOMPLEX_DECLARE_T_
typedef struct FCOMPLEX {float r,i;} fcomplex;
#define _FCOMPLEX_DECLARE_T_
#endif /* _FCOMPLEX_DECLARE_T_ */


#ifndef _ARITHCODE_DECLARE_T_
typedef struct {
   unsigned long *ilob,*iupb,*ncumfq,jdif,nc,minint,nch,ncum,nrad;
} arithcode;
#define _ARITHCODE_DECLARE_T_
#endif /* _ARITHCODE_DECLARE_T_ */

#ifndef _HUFFCODE_DECLARE_T_
typedef struct {
   unsigned long *icod,*ncod,*left,*right,nch,nodemax;
} huffcode;
#define _HUFFCODE_DECLARE_T_
#endif /* _HUFFCODE_DECLARE_T_ */

#include <stdio.h>
#include <string.h>

#if defined(__STDC__) || defined(ANSI) || defined(NRANSI) /* ANSI */

/*void indexx(unsigned long n,double arr[], unsigned long indx[]);*/
void indexx(long n,double arr[],long indx[]);
double ran2(long *idum);
void spline(float x[], float y[], int n, float yp1, float ypn, float y2[]);
void splint(float xa[], float ya[], float y2a[], int n, float x, float *y);
void splie2(float x1a[], float x2a[], float **ya, int m, int n, float **y2a);
void splin2(float x1a[], float x2a[], float **ya, float **y2a, int m, int n, float x1, float x2, float *y);
float plgndr(int l, int m, float x);
double bessj0(double x);
double bessj1(double x);
double bessj(int n, double x);
void ludcmp(double **a, int n, int *indx, double *d);
void lubksb(double **a,int n,int *indx,double b[]);
void mprove(double **a,double **alud,int n,int indx[],double b[],double x[]);

#else /* ANSI */
/* traditional - K&R */
#endif /* ANSI */

#endif /* _NR_H_ */
