/* LELUYA - PERUNIKA program block */
/* This part of the LELUYA code is generating the computational grid */

/* This function gives the adjacent ANTIvertex in a triangle (counter-clockwise
   direction)  
                                          adjacent
         vertex                            vertex
         /    \                            /    \
        /      \                          /      \
       /        \                        /        \
  adjacent----adjacent             adjacent------vertex  
   vertex     antivertex          antivertex

*/

#include "PERUNIKA.h"

struct _vertex_structure *_PERUNIKA_adjacent_antivertex_in_triangle(
		   struct _vertex_structure *v, struct _triangle_structure *t){

  struct _vertex_structure *return_this;

  if      (v==t->v1) return_this = t->v3;
  else if (v==t->v2) return_this = t->v1;
  else if (v==t->v3) return_this = t->v2;
  else return_this = NULL;

  return return_this;
}
