/* LELUYA - PERUNIKA program block */
/* This part of the LELUYA code is generating the computational grid */

/* This function puts a given triangle into the list of triangles at 
   a given vertex */

#include "PERUNIKA.h"

struct _vertex_triangles   *_PERUNIKA_create_new_vertex_triangle (
	                                 struct _triangle_structure *triangle, 
                                         struct _vertex_structure *vertex){
  /* add the 'triangle' to the list of triangles at 'vertex' */

  struct _vertex_triangles   *v, *new_v;

  /* check if the triangle is already there */
  v = vertex->triangles; new_v = NULL;
  while (v!=NULL && new_v==NULL) {
    if (v->triangle == triangle) new_v = v;
    v = v->next;
  }

  /* add the triangle if it is not there */
  if (new_v == NULL) {
    new_v=(struct _vertex_triangles *)malloc(sizeof(struct _vertex_triangles));
    new_v->triangle = triangle;
    new_v->next = NULL;
    if (vertex->triangles != NULL) new_v->next = vertex->triangles;
    vertex->triangles = new_v; 
  }

  return new_v;

}
