/* LELUYA - PERUNIKA program block */
/* This part of the LELUYA code is generating the computational grid */

/* creation of a polygon point */

#include "PERUNIKA.h"

struct _polygon_structure *_PERUNIKA_create_polygon_point 
                              (struct _polygon_structure *polygon,int *error){
  /* polygon  = a polygon to which we need to add a new point */
  int err_location, err;

  struct _polygon_structure *p;
  
  p = (struct _polygon_structure *) malloc (sizeof(struct _polygon_structure));
  if (p == NULL) {
    err_location = 999;
    err = 7;
    _PESJANEK__Error_Message (err_location,err);
    *error = 1;
    return NULL;
  }

  if (polygon == NULL ) {
    polygon = p;
    p->next = p;
    p->prev = p;
  }
  else {
    polygon->prev->next = p;
    p->prev = polygon->prev;
    polygon->prev = p;
    p->next = polygon;
  }

  p->optimal_angle = 2.0; /* this is zero deg */
  p->optimal_vertex = NULL;

  *error = 0;
  return p;
}

