/* LELUYA - PERUNIKA program block */

/* This function creates a new triangle */

#include "PERUNIKA.h"

struct _triangle_structure *_PERUNIKA_create_triangle (int *error) {
  int err_location, err;
  struct _triangle_structure *t;
  
  
  t=(struct _triangle_structure *) malloc (sizeof(struct _triangle_structure));
  if (t==NULL) {
    err_location = 999;
    err = 6;
    _PESJANEK__Error_Message (err_location,err);
    *error = 1;
    return NULL;
  }

  TOTAL_NUMBER_OF_TRIANGLES++;

  if (start_triangle_list == NULL) {
    start_triangle_list = t;
    t->next = t;
    t->prev = t;
  }
  else {
    start_triangle_list->prev->next = t;
    t->prev = start_triangle_list->prev;
    start_triangle_list->prev = t;
    t->next = start_triangle_list;
  }

  t->ID_number = 0;
  t->v1 = t->v2 = t->v3 = NULL;
  t->level = -1;
  t->bound_box_down_left_x = t->bound_box_down_left_z = 0.0;
  t->bound_box_up_right_x = t->bound_box_up_right_z = 0.0;
  t->integral_step = 0.0;

  *error = 0;
  return t;
}
