/* LELUYA - PERUNIKA program block */

/* This function creates a new vertex */

#include "PERUNIKA.h"

struct _vertex_structure *_PERUNIKA_create_vertex (int *error) {
  int err_location,err;
  struct _vertex_structure *v;
  int dust_i;

  v = (struct _vertex_structure *) malloc (sizeof(struct _vertex_structure));

  if (v==NULL) {
    err_location = 999;
    err = 5;
    _PESJANEK__Error_Message (err_location,err);
    *error = 1;
    return NULL;
  }

  TOTAL_NUMBER_OF_VERTICES++;

  if (start_vertex_list == NULL) {
    start_vertex_list = v;
    v->next = v;
    v->prev = v;
  }
  else {
    start_vertex_list->prev->next = v;
    v->prev = start_vertex_list->prev;
    start_vertex_list->prev = v;
    v->next = start_vertex_list;
  }

  v->identification_number=0;
  v->v1=v->v2=v->v3=v->v4=v->v5=v->v6=NULL;
  v->level = -1;
  v->type  = 3;  /* default type is 'fake' */
  v->x = v->z = 0.0;

  v->T_dust = dvector(0,Max_Dust_Type-1);
  v->T_error = dvector(0,Max_Dust_Type-1);
  for (dust_i=0; dust_i<Max_Dust_Type; dust_i++) {
      v->T_dust[dust_i] = -1.0;
      v->T_error[dust_i] = 1.0E30;
  }

  v->Eta = 0.0;
  v->triangles = NULL;

  *error = 0;
  return v;
}

