/* LELUYA - PERUNIKA program block */

/* this function sorts the list of triangles around a given vertex */

#include "PERUNIKA.h"

void _PERUNIKA_sort_triangles_at_vertex(struct _vertex_structure *vertex){
  struct _vertex_triangles   *vertex_triangle;
  struct _vertex_triangles   *another_vertex_triangle;
  struct _triangle_structure *exchange_triangle;
  struct _vertex_structure   *sort_vertex;
  struct _vertex_structure   *zero_direction_point;
  double exchange_nu;

  zero_direction_point=_PERUNIKA_adjacent_vertex_in_triangle(vertex,
				            vertex->triangles->triangle);
  /* find the nu value for each triangle */ 
  vertex->triangles->nu = 2.0;
  vertex_triangle=vertex->triangles->next;
  while (vertex_triangle!=NULL) {
    sort_vertex=_PERUNIKA_adjacent_vertex_in_triangle(vertex,
						  vertex_triangle->triangle);
    vertex_triangle->nu = _MATH_LIB_nu_value(vertex->x,vertex->z,
			       zero_direction_point->x,zero_direction_point->z,
						sort_vertex->x,sort_vertex->z);
    vertex_triangle = vertex_triangle->next;
   }
   /* sort the triangles at the vetex 'loop_vertex' (bubble sort)*/
   vertex_triangle=vertex->triangles;
   do {
     another_vertex_triangle=vertex_triangle->next;
     while (another_vertex_triangle!=NULL) {
       if (another_vertex_triangle->nu > vertex_triangle->nu) {
	 /* exchange the values */
         exchange_triangle = another_vertex_triangle->triangle;
         exchange_nu = another_vertex_triangle->nu;
         another_vertex_triangle->triangle = vertex_triangle->triangle;
         another_vertex_triangle->nu = vertex_triangle->nu;
         vertex_triangle->triangle = exchange_triangle;
         vertex_triangle->nu = exchange_nu;
       }
       another_vertex_triangle=another_vertex_triangle->next;
     }
     vertex_triangle=vertex_triangle->next;
   } while (vertex_triangle!=NULL);
}
