/* LELUYA - PERUNIKA program block */

/* This function finds the intergral step for a given triangle */

#include "PERUNIKA.h"

int _PERUNIKA_triangle_integral_step (struct _triangle_structure *t) {

  struct _vertex_triangles   *vertex_triangle;
  struct _vertex_structure   *vertex1, *vertex2;
  double adjacent1, adjacent2;

  /* (go over all three vertices and find the closest adjacent vertex) */
  t->integral_step = Rout;

  vertex_triangle=t->v1->triangles;
  while (vertex_triangle!=NULL) {
    vertex1=_PERUNIKA_adjacent_vertex_in_triangle(t->v1,
	                                      vertex_triangle->triangle);
    vertex2=_PERUNIKA_adjacent_antivertex_in_triangle(t->v1,
                                              vertex_triangle->triangle);
    adjacent1=_MATH_LIB_distance(t->v1->x,t->v1->z,
				   vertex1->x,vertex1->z);
    adjacent2=_MATH_LIB_distance(t->v1->x,t->v1->z,
				   vertex2->x,vertex2->z);
    if (t->integral_step > adjacent1) t->integral_step = adjacent1;
    if (t->integral_step > adjacent2) t->integral_step = adjacent2;
    vertex_triangle=vertex_triangle->next;
  }

  vertex_triangle=t->v2->triangles;
  while (vertex_triangle!=NULL) {
    vertex1=_PERUNIKA_adjacent_vertex_in_triangle(t->v2,
						vertex_triangle->triangle);
    vertex2=_PERUNIKA_adjacent_antivertex_in_triangle(t->v2,
						vertex_triangle->triangle);
    adjacent1=_MATH_LIB_distance(t->v2->x,t->v2->z,
				   vertex1->x,vertex1->z);
    adjacent2=_MATH_LIB_distance(t->v2->x,t->v2->z,
				   vertex2->x,vertex2->z);
    if (t->integral_step > adjacent1) t->integral_step = adjacent1;
    if (t->integral_step > adjacent2) t->integral_step = adjacent2;
    vertex_triangle=vertex_triangle->next;
  }

  vertex_triangle=t->v3->triangles;
  while (vertex_triangle!=NULL) {
    vertex1=_PERUNIKA_adjacent_vertex_in_triangle(t->v3,
						vertex_triangle->triangle);
    vertex2=_PERUNIKA_adjacent_antivertex_in_triangle(t->v3,
						vertex_triangle->triangle);
    adjacent1=_MATH_LIB_distance(t->v3->x,t->v3->z,
				   vertex1->x,vertex1->z);
    adjacent2=_MATH_LIB_distance(t->v3->x,t->v3->z,
				   vertex2->x,vertex2->z);
    if (t->integral_step > adjacent1) t->integral_step = adjacent1;
    if (t->integral_step > adjacent2) t->integral_step = adjacent2;
    vertex_triangle=vertex_triangle->next;
  }

  if (t->integral_step == Rout) return 1;

  return 0;
}

