/* LELUYA - PESJANEK program block */
/* Function which gives the debugger messages */

#include <stdio.h>

#include "PESJANEK.h"

void _PESJANEK__Debugger_Message (int message_location,int message){
  /* message_location: gives the information about the location where 
                       a message is required */
  /* message         : specifies the message */
  
  printf("\n2D DUSTY DEBUGGER: message #%.3d:%.3d\n",message_location,message);
  printf("  process = %.3d\n",my_MPI_rank);
  /**************************************************************************/
  /****************** message_location = 1 **********************************
                  messages in the PERUN block
  ***************************************************************************/
  if (message_location == 1 ) {
    printf("-- message location: PERUN block\n");
    if (message == 1) {
      printf("-- description: command line parameters\n");
      printf("  DEBUGGING FLAGS STATUS:\n");
      printf("    DEBUG.SCREEN_MESSAGE = %d\n",DEBUG.SCREEN_MESSAGE);
      printf("    DEBUG.STOP = %d\n",DEBUG.STOP);
      printf("  Other command line informations:\n");
      /* the rest of this message is given in the PERUN block */
    } /* end of (message == 1 )*/

  } /* end of (message_location == 1 ) */
  
  /**************************************************************************/
  /****************** message_location = 2 **********************************
                  messages in the PATULJAK block
  ***************************************************************************/
  if (message_location == 2 ) {
    printf("-- message location: PATULJAK block \n");
    printf("----------------------------------------------------------\n");
    if (message == 1) {
      printf("-- description: input of the lambda grid\n");
    }

    if (message == 2) {
      printf("-- description: input of the total optical depth\n");
    }

    if (message == 3) {
      printf("-- description: input of the central energy source flux\n");
    }

     if (message == 4) {
      printf("-- description: input of the dust properties\n");
    }

     if (message == 5) {
      printf("-- description: input of the dust density profiles\n");
    }

    printf("----------------------------------------------------------\n");
 }

} /* end of the "_PESJANEK__Debugger_Message" function */
