/* LELUYA - PESJANEK program block */
/* this function is saving all global data created in the input part of the 
   code. 
   That is, all data created before the stop marked by DEBUG.STOP=2  */

/* the list of the dumped variables (in exactly that order!) :
   
   int     MAX_Dust_Type
   int     INPUT.LAMBDA_TYPE
   int     INPUT.SOURCE_TYPE
   int     INPUT.DUST_TYPE[Max_Dust_Type]
   int     INPUT.DUST_DENSITY_TYPE[Max_Dust_Type]
   char   *INPUT.DUST_DENSITY_TYPE_NAME[Max_Dust_Type]
   int     lambda_Max
   double  Lambda_Grid[lambda_Max]
   double  Tau_Total
   double  Theta_Total_Value
   int     Theta_Total
   double  Lambda_Total_Value
   int     Lambda_Total
   double  Source_Flux[lambda_Max]
   double  Rout
   double  Source_Radius
   double  Source_Teff
   char   *Dust_Component_Name[Max_Dust_Type]
   double  Dust_Sublim_Temp[Max_Dust_Type]
   double  Sigma_Dust_Abs[Max_Dust_Type][lambda_Max]
   double  Sigma_Dust_Sca[Max_Dust_Type][lambda_Max]
   int     Dust_Density_Param.next   --> repeat Dust_Density_Param 
   double  Dust_Density_Param.param  --> while (Dust_Density_Param.next != NULL)
   double  Eta_Denominator
   double  Psi
*/

#include "PESJANEK.h"

int _PESJANEK_Dump_Data_STOP2 ( void ) {

  FILE *DUMP_FILE;
  char filename[256];
  int  dust_i, lambda_k, a;
  struct density_parameters *density_param_dump;
  int err_location, err;

  if (my_MPI_rank!=0) return 0;

#ifdef _2DD_MPI_
  sprintf(filename,"%s/LELUYA.dump.STOP2.2dd",_LELUYA_MPIOUT_PATH);
  if (DEBUG.STOP==3 || DEBUG.STOP>=300)
    sprintf(filename,"%s/LELUYA.dump.STOP3_%.2d_%.2d.2dd",
            _LELUYA_MPIOUT_PATH,GLOBAL_BIN_COUNTER,
	  GLOBAL_ITERATION_COUNTER);
#else
  sprintf(filename,"%s/LELUYA.dump.STOP2.2dd",_LELUYA_OUTPUT_PATH);
  if (DEBUG.STOP==3 || DEBUG.STOP>=300)
    sprintf(filename,"%s/LELUYA.dump.STOP3.2dd",_LELUYA_OUTPUT_PATH);
#endif
  DUMP_FILE=fopen(filename,"w");
  if (DUMP_FILE == NULL ) {
    err_location = 999;
    err = 2;
    _PESJANEK__Debugger_Message (err_location,err);
    printf("%s\n",filename);
    return 1;
  }

  if (DEBUG.SCREEN_MESSAGE >= 1 ) {
    printf("_PESJANEK_Dump_Data_STOP2: !!! DUMPING OF THE GLOBAL VARIABLES !!!\n");
  }

  fprintf(DUMP_FILE,"---- LELUYA: Dumped variables at STOP=2 -----\n");
  fprintf(DUMP_FILE,"---- LELUYA: Dumped variables at STOP=2 -----\n");
  fprintf(DUMP_FILE,"---- LELUYA: Dumped variables at STOP=2 -----\n");

  fprintf(DUMP_FILE,"%d  = Max_Dust_Type\n",Max_Dust_Type);

  fprintf(DUMP_FILE,"%d  = INPUT.LAMBDA_TYPE\n",INPUT.LAMBDA_TYPE);

  fprintf(DUMP_FILE,"%d  = INPUT.SOURCE_TYPE\n",INPUT.SOURCE_TYPE);

  fprintf(DUMP_FILE,"INPUT.DUST_TYPE[Max_Dust_Type] : \n");
  for (dust_i=0; dust_i<Max_Dust_Type; dust_i++)
    fprintf(DUMP_FILE,"%.3d  %d\n",dust_i,INPUT.DUST_TYPE[dust_i]);

  fprintf(DUMP_FILE,"INPUT.DUST_DENSITY_TYPE[Max_Dust_Type] : \n");
  for (dust_i=0; dust_i<Max_Dust_Type; dust_i++)
    fprintf(DUMP_FILE,"%.3d  %d\n",dust_i,INPUT.DUST_DENSITY_TYPE[dust_i]);

  fprintf(DUMP_FILE,"INPUT.DUST_DENSITY_TYPE_NAME[Max_Dust_Type] : \n");
  for (dust_i=0; dust_i<Max_Dust_Type; dust_i++)
    fprintf(DUMP_FILE,"%s\n",INPUT.DUST_DENSITY_TYPE_NAME[dust_i]);

  fprintf(DUMP_FILE,"%d  = lambda_Max\n",lambda_Max);

  fprintf(DUMP_FILE,"Lambda_Grid[lambda_Max] : \n");
  for (lambda_k=0; lambda_k<lambda_Max; lambda_k++)
    fprintf(DUMP_FILE,"%.3d  %E\n",lambda_k, Lambda_Grid[lambda_k]);

  fprintf(DUMP_FILE,"%E  = Tau_Total\n",Tau_Total);

  fprintf(DUMP_FILE,"%E  = Theta_Total_Value\n",Theta_Total_Value);

  fprintf(DUMP_FILE,"%d  = Theta_Total\n",Theta_Total);

  fprintf(DUMP_FILE,"%E  = Lambda_Total_Value\n",Lambda_Total_Value);

  fprintf(DUMP_FILE,"%d  = Lambda_Total\n",Lambda_Total);

  fprintf(DUMP_FILE,"Source_Flux[lambda_Max] : \n");
  for (lambda_k=0; lambda_k<lambda_Max; lambda_k++)
    fprintf(DUMP_FILE,"%.3d  %E\n",lambda_k,Source_Flux[lambda_k]);

  fprintf(DUMP_FILE,"%E  = Rout\n",Rout);

  fprintf(DUMP_FILE,"%E  = Source_Radius\n",Source_Radius);

  fprintf(DUMP_FILE,"%E  = Source_Teff\n",Source_Teff);

  fprintf(DUMP_FILE,"Dust_Component_Name[Max_Dust_Type] : \n");
  for (dust_i=0; dust_i<Max_Dust_Type; dust_i++)
    fprintf(DUMP_FILE,"name%.3d=%s\n",dust_i,Dust_Component_Name[dust_i]);

  fprintf(DUMP_FILE,"Dust_Sublim_Temp[Max_Dust_Type] : \n");
  for (dust_i=0; dust_i<Max_Dust_Type; dust_i++)
    fprintf(DUMP_FILE,"%.3d  %E\n",dust_i,Dust_Sublim_Temp[dust_i]);

  fprintf(DUMP_FILE,"Sigma_Dust_Abs AND Sigma_Dust_Sca ");
  fprintf(DUMP_FILE,"[Max_Dust_Type][lambda_Max] : \n");
  for (dust_i=0; dust_i<Max_Dust_Type; dust_i++) {
    fprintf(DUMP_FILE,"   Sigma_Dust_Abs AND Sigma_Dust_Sca[%.3d] : \n",dust_i);
    for (lambda_k=0; lambda_k<lambda_Max; lambda_k++)
      fprintf(DUMP_FILE,"%.3d  %E  %E\n",lambda_k,
             Sigma_Dust_Abs[dust_i][lambda_k],Sigma_Dust_Sca[dust_i][lambda_k]);
  }

  fprintf(DUMP_FILE,"Dust_Density_Param[Max_Dust_Type] :\n");
  for (dust_i=0; dust_i<Max_Dust_Type; dust_i++) {
    a = 1;
    density_param_dump = &Dust_Density_Param[dust_i];
    do {
      if (density_param_dump->next == NULL)
        fprintf(DUMP_FILE,"0  = Dust_Density_Param[%.3d]->next = NULL\n",dust_i);
      else 
        fprintf(DUMP_FILE,"%d  = Dust_Density_Param[%.3d]->next\n",a,dust_i);
      fprintf(DUMP_FILE,"%15.13E  = Dust_Density_Param[%.3d]->param\n",
              density_param_dump->param,dust_i);
      density_param_dump = density_param_dump->next;
      a++;
    } while (density_param_dump !=NULL);
  }

  fprintf(DUMP_FILE,"%E  = Eta_Denominator\n",Eta_Denominator);

  fprintf(DUMP_FILE,"%E  = Psi\n",Psi);

  fprintf(DUMP_FILE,"%E  = CELL_SIZE_LIMIT\n",CELL_SIZE_LIMIT);

  fprintf(DUMP_FILE,"------------- END -----------------------\n");

  fclose(DUMP_FILE);

  return 0;

}
