/* LELUYA - PESJANEK program block */
/* Functions which are dealing with the error messages */

#include <stdio.h>

#include "PESJANEK.h"

void _PESJANEK__Error_Message (int err_location,int err){
  /* err_location: gives the information about the location from where 
                   an error function was called */
  /* err         : gives the exact description of the error */
  
  printf("**********************************************************\n");
  printf("**********************************************************\n");
  printf("\n\n2D DUSTY ERROR %.3d:%.3d\n",err_location,err);
  printf("  process = %.3d\n",my_MPI_rank);
  /**************************************************************************/
  /****************** err_location = 1 **************************************
     errors produced in the PERUN block during the analysis of input 
     debugging flags and global input file name                      
  ***************************************************************************/
  if (err_location == 1 ) {
    printf("-- error function called from: 2DD-PERUN\n");

    if (err == 1) {
      printf("---- error location: LEPAMARA block\n");
      printf("------ error function: _LEPAMARA__Analyze_Input_Flags\n");
      printf("-------- error description: ");
      printf("the command line flags are missing or\n");
      printf("                            not properly specified\n");
    } /* end of (err == 1 )*/

    if (err == 2) {
      printf("---- error location: LEPAMARA block\n");
      printf("------ error function: _LEPAMARA__Analyze_Input_Flags\n");
      printf("-------- error description: ");
      printf("a name of the global input file is \n");
      printf("    specified more then once\n");
    } /* end of (err == 2 )*/

    if (err == 3) {
      printf("---- error location: LEPAMARA block\n");
      printf("------ error function: _LEPAMARA__Analyze_Input_Flags\n");
      printf("-------- error description: ");
      printf("some of the specified command line flags don't exist\n");
    } /* end of (err == 3 )*/

    if (err == 4) {
      printf("---- error location: LEPAMARA block\n");
      printf("------ error function: _LEPAMARA__Analyze_Input_Flags\n");
      printf("-------- error description: ");
      printf("at least one command line flag is specified more then once\n");
    } /* end of (err == 4 )*/

    if (err == 5) {
      printf("---- error location: PERUN block\n");
      printf("------ error function: main()\n");
      printf("-------- error description: ");
      printf("the global input file can't be open!! Check its name!\n");
      printf("         ");
    } /* end of (err == 5 )*/

    if (err == 6) {
      printf("---- error location: PERUN block\n");
      printf("------ error function: main()\n");
      printf("-------- error description: ");
      printf("The '-c' flag can not start anything !!\n");
    } /* end of (err == 6 )*/

    if (err == 7) {
      printf("---- error location: LEPAMARA block\n");
      printf("------ error function: _LEPAMARA__Analyze_Input_Flags\n");
      printf("-------- error description: ");
      printf("the STOP '-s' flag has to be bigger \n");
      printf("then the CONTINUE '-c' flag!!\n");
    } /* end of (err == 7 )*/

  } /* end of (err_location == 1 ) */

  /**************************************************************************/
  /****************** err_location = 2 **************************************
       errors produced in the PERUN block due to the STOP flag
       This flag can be activated by the user for debugging purposes.
  ***************************************************************************/
  if (err_location == 2 ) {
    printf("-- error location: PERUN block\n");
    printf("---- WARNING!! The program is stopped due to the user's \n");
    printf("               command line flag: ");

    if (err == 1) {
      printf("-s 1\n");
      printf("     location of the stop: after the analysis of command\n");
      printf("               line flags\n");
    } /* end of (err == 1 )*/

    if (err == 2) {
      printf("-s 2\n");
      printf("     location of the stop: after the data input,\n");
      printf("               before any calculation has started\n");
    } /* end of (err == 2 )*/

  } /* end of (err_location == 2 ) */

  /**************************************************************************/
  /****************** err_location = 3 **************************************
   errors produced in the PATULJAK block when it reads the lambda grid
  ***************************************************************************/
  if (err_location == 3 ) {
    printf("-- error location: PATULJAK block\n");
    printf("---- error function called from: _PATULJAK__Read_Input_Data\n");
    printf("------ error function: _PATULJAK__Read_Lambda_Grid\n");
    printf("-------- error description: ");
 
    if (err == 1 ){
      printf("problems with the lambda grid input flag\n");
      printf("    in the global file ");
    }

    if (err == 2 ){
      printf("can't open the lambda grid file\n");
    }

    if (err == 3 ){
     printf("problems during the reading of data from the lambda grid file\n");
    }

    if (err == 4 ){
      printf("nonexisting lambda grid option flag\n");
    }

  } /* end of (err_location == 3 ) */
  /**************************************************************************/
  /****************** err_location = 4 **************************************
   errors produced in the PATULJAK block when it reads the total optical
   depth parameters 
  ***************************************************************************/
  if (err_location == 4 ) {
    printf("-- error location: PATULJAK block\n");
    printf("---- error function called from: _PATULJAK__Read_Input_Data\n");
    printf("------ error function: _PATULJAK__Read_Tau_Total\n");
    printf("-------- error description: ");
 
    if (err == 1 ){
      printf("can not find the total optical \n");
      printf("    depth value in ");
    }

    if (err == 2 ){
      printf("can not read the specified total \n");
      printf("    optical depth in ");
    }

    if (err == 3 ){
      printf("can not find the azimuthal angle of the\n");
      printf("    total optical depth in ");
    }

    if (err == 4 ){
      printf("can not read the specified azimuthal angle of the\n");
      printf("    total optical depth in ");
    }

    if (err == 5 ){
      printf("the azimuthal angle of the total optical depth\n");
      printf("    is out of range (0-90 deg)\n");
    }

    if (err == 6 ){
      printf("can not find the wavelength of the\n");
      printf("    total optical depth in ");
    }

    if (err == 7 ){
      printf("can not read the specified wavelength of the\n");
      printf("    total optical depth in ");
    }

    if (err == 8 ){
      printf("the wavelength of the total optical depth is \n");
      printf("    out of lambda grid range ");
    }

    if (err == 9 ){
      printf("can not read the outer radius\n");
      printf("   from the file");
    }


  } /* end of (err_location == 4 ) */
  /**************************************************************************/
  /****************** err_location = 5 **************************************
   errors produced in the PATULJAK block when it reads the source flux
  ***************************************************************************/
  if (err_location == 5 ) {
    printf("-- error location: PATULJAK block\n");
    printf("---- error function called from: _PATULJAK__Read_Input_Data\n");
    printf("------ error function: _PATULJAK__Read_Source_Flux\n");
    printf("-------- error description: ");

    if (err == 1) {
      printf("the input source flux flag is not specified properly\n");
      printf("    in the file  ");
    }

    if (err == 2) {
      printf("OPTION 0: can not read temperature of the central source\n");
      printf("    from the file ");
    }


  } /* end of (err_location == 5 ) */

  /**************************************************************************/
  /****************** err_location = 6 **************************************
   errors produced in the PATULJAK block when it reads the dust chemical and
   physical properties
  ***************************************************************************/
  if (err_location == 6 ) {
    printf("-- error location: PATULJAK block\n");
    printf("---- error function called from: _PATULJAK__Read_Input_Data\n");
    printf("------ error function: _PATULJAK__Read_Dust_Sigmas\n");
    printf("-------- error description: ");
 
    if (err == 1 ){
      printf("can not locate the total number of different\n");
      printf("    dust components specified in ");
    }

    if (err == 2){
      printf("the total number of different dust components is\n");
      printf("    smaller then 1 or it can not\n");
      printf("    be read from ");
    }

    if (err == 3) {
      printf("can not read or locate the sublimation temperature\n");
      printf("    for the dust component ");
    }

    if (err == 4) {
      printf("the input dust property flag is not specified properly\n");
      printf("    for the dust component ");
    }

    if (err == 5) {
      printf("the file with cross sections ether can not be opened \n");
      printf("    or its name is not correct\n");
      printf("    for the dust component ");
    }

    if (err == 6) {
      printf("error while reading the cross sections from a data file\n");
      printf("    for the dust component ");
    }

    if (err == 7) {
      printf("wavelengths are not sorted in the file with cross sections\n");
      printf("    for the dust component ");
    }

    if (err == 8) {
      printf("can not interpolate cross sections from the input data\n");
      printf("    for the dust component ");
    }

  } /* end of (err_location == 6 ) */

  /**************************************************************************/
  /****************** err_location = 7 **************************************
   errors produced in the PATULJAK block when it reads the dust density
   profiles
  ***************************************************************************/
  if (err_location == 7 ) {
    printf("-- error location: PATULJAK block\n");
    printf("---- error function called from: _PATULJAK__Read_Input_Data\n");
    printf("------ error function: _PATULJAK__Read_Dust_Density\n");
    printf("-------- error description: ");
 
    if (err == 1 ){
      printf("can not read a dust density profile flag\n");
      printf("    for the dust component ");
    }

    if (err == 2 ){
      printf("  the dust density profiles should be the same for all\n");
      printf("  components, but it can not read the flag of the first\n");
      printf("  component in the file ");
    }

    if (err == 3 ){
      printf("  the dust density profiles should be the same for all\n");
      printf("  components, but it can not read the density profile \n");
      printf("  parameters of the first component in the file ");
    }

    if (err == 4 ){
      printf("  can not read the dust density parameters for the dust\n");
      printf("  component ");
    }


  } /* end of (err_location == 7 ) */
  /**************************************************************************/


  /****************** err_location = 8 **************************************
   errors produced in the LEPAMARA block during the calculation of the initial 
   eta denominator 
  ***************************************************************************/
  if (err_location == 8 ) {
    printf("-- error location: LEPAMARA block\n");
    printf("---- error function called from: ");
    printf("_LEPAMARA_Find_Initial_Eta_Denominator\n");
 
    if (err == 1 || err == 2){
      printf("------ error function: q_abs (ZELENJAK block)\n");
      printf("-------- error description: ");
      printf("can not find the absorption coefficient\n");
      if (err == 1) 
        printf("NOTE: this is BEFORE the eta denominator calculation\n");
      if (err == 2) 
        printf("NOTE: this is AFTER the eta denominator calculation\n");
    }

    if (err == 3 || err == 4) {
      printf("------ error function: _GOROSTAS_Find_Temperature\n");
      printf("-------- error description: ");
      printf("Can not find the dust temperature\n");
      printf("during the iteration process \n");
      if (err == 3) 
        printf("(bracketing temperatures didn't work!)\n");
      if (err == 4) 
        printf("(_MATH_LIB_Ridder_Root can not find the solution)\n");
    }

  } /* end of (err_location == 8 ) */
  /**************************************************************************/


  /****************** err_location = 9 **************************************
   errors produced in the PERUNIKA block
  ***************************************************************************/
  if (err_location == 9 ) {
    printf("-- error location: PERUNIKA block\n");

    if (err == 1 || err == 2) {
      printf("---- error function called from: _PERUNIKA_Create_Initial_Array");
      printf("------ error function: _GOROSTAS_Find_Temperature\n");
      printf("-------- error description: ");
      printf("Can not find the dust temperature\n");
      if (err == 1) 
        printf("(bracketing temperatures didn't work!)\n");
      if (err == 2) 
        printf("(_MATH_LIB_Ridder_Root can not find the solution)\n");
    }

    if (err == 3) {
      printf("------ error function: _PERUNIKA_main\n");
      printf("-------- error description: ");
      printf("Can not open the file with\n");
      printf("initial temperature and energy density approximation:\n");
    }

    if (err == 4) {
      printf("------ error function: _PERUNIKA_main\n");
      printf("-------- error description: ");
      printf("Data in the dump file is not compatible\n");
      printf("with the current data structure\n");
    }

    if (err == 5) {
      printf("------ error function: _PERUNIKA_analyze_triangle\n");
      printf("-------- error description: ");
      printf("can not generate the computational\n");
      printf("grid. What's the problem? Well,... there should be a grid\n");
      printf("point at the location where I can not find any. \n");
    }

  } /* end of (err_location == 9 ) */
  /**************************************************************************/

  /****************** err_location = 10 *************************************
   errors produced in the VILOZMAJ block during the calculation of   
   the temperatures at the grid vertices
  ***************************************************************************/
  if (err_location == 10 ) {
    printf("-- error location: VILOZMAJ block\n");
    printf("---- error function called from: ");
    printf("_VILOZMAJ_Find_New_Temperature\n");
 
    if (err == 1 || err == 2) {
      printf("------ error function: _GOROSTAS_Find_Temperature\n");
      printf("-------- error description: ");
      printf("Can not find the dust temperature\n");
      printf("during the iteration process \n");
      if (err == 1) 
        printf("(bracketing temperatures didn't work!)\n");
      if (err == 2) 
        printf("(_MATH_LIB_Ridder_Root can not find the solution)\n");
    }

  } /* end of (err_location == 10 ) */
  /**************************************************************************/


  /**************************************************************************/
  /****************** err_location = 999 ************************************
   errors produced somewhere in the code, without unique location
  ***************************************************************************/
  if (err_location == 999 ) {

    if (err == 1) {
      printf("- error location: _PATULJAK_Read_Input_Data\n");
      printf("-- error description: can't scale the cross sections\n");
    }

    if (err == 2) {
      printf("- error location: _PESJANEK_Dump_Data_STOP2\n");
      printf("-- error description: can't open the dump file:");
    }

    if (err == 3) {
      printf("- error location: _LEPAMARA_Read_Data_CONTINUE2\n");
      printf("-- error description: can't open the input dump file:");
    }

    if (err == 4) {
      printf("- error location: _LEPAMARA_Read_Data_CONTINUE2\n");
      printf("-- error description: can not read data from the dump file:");
    }

    if (err == 5) {
      printf("- error location: _PERUNIKA_create_vertex\n");
      printf("-- error description: can not allocate memory for");
      printf(" a new vertex\n");
    }

    if (err == 6) {
      printf("- error location: _PERUNIKA_create_triangle\n");
      printf("-- error description: can not allocate memory for");
      printf(" a new triangle\n");
    }

    if (err == 7) {
      printf("- error location: _PERUNIKA_create_polygon_point\n");
      printf("-- error description: can not allocate memory for");
      printf(" a new polygon point\n");
    }



  }

} /* end of the "_PESJANEK__Error_Message" function */
