/* LELUYA - VILOZMAJ program block */
/* Prototypes of functions for the radiative transfer calculation */

#ifndef _VILOZMAJ_prototypes_
#define _VILOZMAJ_prototypes_

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "../_global_extern_variables.h"
#include "../PESJANEK/PESJANEK.h"
#include "../ZELENJAK/ZELENJAK.h"
#include "../VODENJAK/VODENJAK.h"
#include "../GOROSTAS/GOROSTAS.h"
#include "../MATH_LIB/MATH_LIB.h"
#include "../MATH_LIB/nrutil.h"

/**********************************************************************/
/* global structure and variables */
  /* structure of a lambda-job */
  struct _lambda_job_struct {
    struct _lambda_job_struct *next;
    int ID; /* identification number */
    int N;
    int *run;  /* list of N wavelengths for one run of
                _VILOZMAJ_Radiative_Transfer_Solver */
    int solved; /* flag which shows if this job has been solved:
                   FALSE = not solved yet
                   TRUE (1) = solved
                   TRUE (2) = currently under work */
  };
  /* lambda_jobs */
  extern struct _lambda_job_struct *lambda_jobs;
  extern int total_number_of_lambda_jobs;
  extern int current_lambda_job; /* ID of the lambda_job that has solved==2 */

/*********************************************************************/

#ifdef _2DD_MPI_
/* flags that show which processors are available for rad. trans. */
extern int *_MPI_Process_Available;
#endif

int _VILOZMAJ_main (void); 

void _VILOZMAJ_Radiative_Transfer_Solver(int Lambda_List_Total,int *Lambda_List);

int _VILOZMAJ_Output_Image_Flux(double theta_view,int *TOTAL_NUMBER_OF_IMAGE_CELLS,
			    struct _image_cell_structure **Image_);

int _VILOZMAJ_Find_New_Temperature( void );

double _VILOZMAJ_Intensity_Integral(int lambda_k, struct _3DVector start_point, 
                             struct _3DVector integral_direction,
                             double *Intensity_em, double *Intensity_sca,
                             int use_old_grid);

int _VILOZMAJ_Luminosity_shells (void);

int _VILOZMAJ_Radial_Profiles (void);

int _VILOZMAJ_Temperature_Array (int dust_i);

#endif

