/* LELUYA - VODENJAK program block */
/* Prototypes of functions for plotting GIF images, VRML worlds, etc.. */

#ifndef _VODENJAK_prototypes_
#define _VODENJAK_prototypes_

#include <stdio.h>
#include <math.h>
#include "../_global_extern_variables.h"
#include "../PESJANEK/PESJANEK.h"
#include "../PERUNIKA/PERUNIKA.h"
#include "../ZELENJAK/ZELENJAK.h"
#include "../MATH_LIB/MATH_LIB.h"
#include "../MATH_LIB/nrutil.h"
#include "image_hash.h"
#include "eimage_lib.h"

int _VODENJAK_plot_image (char image_name[255],
                          double (*func)(double,double,int,int),
                          int image_type,double minX, double maxX, double minY,
                          double maxY, int dust_i, int lambda_k);
int _VODENJAK_plot_vrml(char image_name[255],int wrml_type, 
                        int dust_i, int lambda_k) ;
int _VODENJAK_plot_dust_edge_vrml(char image_name[255],int lambda_k);

int _VODENJAK_plot_interactive_vrml(char image_name[255],
                        int dust_i, int lambda_k) ;

int _VODENJAK_plot_PovRay(char image_name[255], int dust_i, int lambda_k) ;

int _VODENJAK_plot_angular_integral_rays(struct _vertex_structure *main_vertex,
                                         char image_name[255],int N_phi_grid);

double _VODENJAK_tau_over_grid (struct _3DVector startpoint, 
			        struct _3DVector endpoint, int lambda_k);

int _VODENJAK_plot_radiative_transfer_matrix (double **matrixA, 
                                double *vectorB, int lambda_k);

int _VODENJAK_image_vrml (double theta_view,
			  struct _image_cell_structure *Image);

#endif

