/* LELUYA - ZELENJAK program block */
/* calculation of the eta function from a given set of information */

#include "ZELENJAK.h"

double Eta (double x, double z, int lambda_i, double *T, int *err){
  /* x,z            = coordinates of the point where we need the Eta value
     lambda_i       = index of the wavelength
     T              = temperature at the point where we need the Eta value
     err            = error flag
  */

  int i;
  double _eta;
  int error;

  _eta = 0.0; error = 0;
  for (i=0; i<Max_Dust_Type; i++) 
    /* if (INPUT.DUST_DENSITY_TYPE[i]!=99999) */
    if ( (Max_Dust_Temp<=0.0 && 
          T[i] <= Dust_Sublim_Temp[i]*(1.0+_SUBLIMATION_TOLERANCE_) && T[i]>0.0)
        ||
         (Max_Dust_Temp>0.0 && T[i] <= Max_Dust_Temp && T[i]>0.0) ) {
      _eta += ((Sigma_Dust_Abs[i][lambda_i] + Sigma_Dust_Sca[i][lambda_i])*
              Dust_Density(x,z,i,NULL,&error));
      if (error) {*err = 1; return 0.0;}
    }

  _eta *= (Tau_Total / Eta_Denominator);

  *err = 0;
  return _eta;
}
