/* This function is searching for a vertex which can be used for copying the data 
   to another vertex (given in the input) */
/* This function is used when the grid at different wavelengths have a missmatch */

#include "ZELENJAK.h"


struct _vertex_structure *_ZELENJAK_Find_Adjacent_Temperature 
           (struct _vertex_structure *v, int dust_i){

  int flag_Temp_found = 0;
  int flag_all_none = 1;
  struct _vertex_triangles   *vertex_triangle;
  struct _triangle_structure *triangle;
  struct _vertex_structure   *v1, *v2;
  double T = 0.0;
  struct _vertex_structure   *vertex_out;

  vertex_out = NULL;
  vertex_triangle = v->triangles;
  if (v->type == 2)
    while (vertex_triangle!=NULL && flag_Temp_found==0) {
      v1 = _PERUNIKA_adjacent_vertex_in_triangle(v,vertex_triangle->triangle);
      if (v1->type==2 && v1->T_dust[dust_i]>0.0) {
        vertex_out = v1;
        flag_Temp_found = 1;
      }
      v2 = _PERUNIKA_adjacent_antivertex_in_triangle(v,vertex_triangle->triangle);
      if (v2->type==2 && v2->T_dust[dust_i]>0.0) {
        vertex_out = v2;
        flag_Temp_found = 1;
      }
      vertex_triangle = vertex_triangle->next;
    }
  else {
    while (vertex_triangle!=NULL) {
      v1 = _PERUNIKA_adjacent_vertex_in_triangle(v,vertex_triangle->triangle);
      if (v1->T_dust[dust_i] > T) {
        T = v1->T_dust[dust_i];
        vertex_out = v1;
      }
      if (v1->T_dust[dust_i] > 0.0 && v1->type!=2) flag_all_none=0;

      v2 = _PERUNIKA_adjacent_vertex_in_triangle(v,vertex_triangle->triangle);
      if (v2->T_dust[dust_i] > T) {
        T = v2->T_dust[dust_i];
        vertex_out = v2;
      }
      if (v2->T_dust[dust_i] > 0.0 && v2->type!=2) flag_all_none=0;
      vertex_triangle = vertex_triangle->next;
    }
    if (flag_all_none==1) vertex_out = NULL;
  }
  return vertex_out;
}
