/* LELUYA - ZELENJAK program block */
/* Calculation of the source size (radius). */

/* NOTE: currently, only the point-source approximation is implemented.
         In addition, the source is a black body with temperature Teff.
         This gives the scaled radius:
   
         Source_Radius = (4/Psi)^0.5 (Tsub/Teff)^2
*/


#include "ZELENJAK.h"

int _ZELENJAK_Find_Source_Radius(void){


  /* this is solution based on the point-source approximation */

  double new_Source_Radius;

  new_Source_Radius = Dust_Sublim_Temp[0]/Source_Teff;
  new_Source_Radius *= new_Source_Radius;
  new_Source_Radius = new_Source_Radius*2.0/sqrt(Psi);

  printf("SEARCH FOR A NEW SOURCE RADIUS:\n");
  printf("Old source radius=%E, new radius=%E\n",
	 Source_Radius,new_Source_Radius);

  Source_Radius=new_Source_Radius;

  return 0;
}
