/* LELUYA - ZELENJAK program block */
/* exchange two dust components */
/* This is usually used in sorting of the dust components */

#include "ZELENJAK.h"

int _ZELENJAK_exchange_components(int dust1, int dust2) {
  /* exchange dust components dust1 and dust2 */

  /* variables for help in this exchange: */
  double help1d,help5d;
  struct density_parameters help4dp;
  int    help2i,dust3;
  char   help3c;

  /* temperature */
  help1d = Dust_Sublim_Temp[dust2];
  Dust_Sublim_Temp[dust2] = Dust_Sublim_Temp[dust1];
  Dust_Sublim_Temp[dust1] = help1d;

  /* dust density parameters */
  help4dp.next = Dust_Density_Param[dust2].next;
  help4dp.param = Dust_Density_Param[dust2].param;
  Dust_Density_Param[dust2].next = Dust_Density_Param[dust1].next;
  Dust_Density_Param[dust2].param =Dust_Density_Param[dust1].param;
  Dust_Density_Param[dust1].next = help4dp.next;
  Dust_Density_Param[dust1].param = help4dp.param;

  /* INPUT parameters */
  help2i = INPUT.DUST_TYPE[dust2];
  INPUT.DUST_TYPE[dust2] = INPUT.DUST_TYPE[dust1];
  INPUT.DUST_TYPE[dust1] = help2i;
  help2i = INPUT.DUST_DENSITY_TYPE[dust2];
  INPUT.DUST_DENSITY_TYPE[dust2] = INPUT.DUST_DENSITY_TYPE[dust1];
  INPUT.DUST_DENSITY_TYPE[dust1] = help2i;
  for (dust3=0;dust3<_DUST_COMPONENT_NAME_SIZE_;dust3++){
    help3c = Dust_Component_Name[dust2][dust3];
    Dust_Component_Name[dust2][dust3] = 
                             Dust_Component_Name[dust1][dust3];
    Dust_Component_Name[dust1][dust3] = help3c;
  }
  for (dust3=0;dust3<_DUST_DENSITY_TYPE_NAME_SIZE_;dust3++){
    help3c = INPUT.DUST_DENSITY_TYPE_NAME[dust2][dust3];
    INPUT.DUST_DENSITY_TYPE_NAME[dust2][dust3] = 
                             INPUT.DUST_DENSITY_TYPE_NAME[dust1][dust3];
    INPUT.DUST_DENSITY_TYPE_NAME[dust1][dust3] = help3c;
    }

  /* absorption and scattering cross sections */
  for (dust3=0;dust3<lambda_Max;dust3++){
    help1d = Sigma_Dust_Abs[dust2][dust3];
    help5d = Sigma_Dust_Sca[dust2][dust3];
    Sigma_Dust_Abs[dust2][dust3] = Sigma_Dust_Abs[dust1][dust3];
    Sigma_Dust_Sca[dust2][dust3] = Sigma_Dust_Sca[dust1][dust3];
    Sigma_Dust_Abs[dust1][dust3] = help1d;
    Sigma_Dust_Sca[dust1][dust3] = help5d;
  }   

  return 0;
}
