/* LELUYA - ZELENJAK program block */

/* This function is checking if a triangle contains a point */

#include "ZELENJAK.h"

int _ZELENJAK_point_in_triangle(double x,double z,
                                struct _triangle_structure *t){

  int I_have_found_it;
  double nu1,nu2,nu3;
  struct _triangle_structure *triangle;


  if (t==NULL) return 0;

  I_have_found_it = 0; 

  /* check if the point (x,z) is inside of the bounding box */
  if (x >= 0.9999*t->bound_box_down_left_x) 
  if (z >= 0.9999*t->bound_box_down_left_z)
  if (x <= 1.0001*t->bound_box_up_right_x)  
  if (z <= 1.0001*t->bound_box_up_right_z) {
    /* check if the point (x,z) is inside of the triangle */
    /* This is the case if the point (x,z) is on the left side relative
       to all triangle's sides:

                    (x,z)
                     /
                    /    LEFT
                   / 
                vertex(i)-------vertex(i+1)

                        RIGHT
    */

    nu1=_MATH_LIB_nu_value(t->v1->x,t->v1->z,
      		       t->v2->x,t->v2->z,x,z);
    nu2=_MATH_LIB_nu_value(t->v2->x,t->v2->z,
       		       t->v3->x,t->v3->z,x,z);
    nu3=_MATH_LIB_nu_value(t->v3->x,t->v3->z,
       		       t->v1->x,t->v1->z,x,z);
    if (0.0<=nu1 && 0.0<=nu2 && 0.0<=nu3) {
      /* bingo! That's the triangle! */
      I_have_found_it = 1; 
    }
  }

  return I_have_found_it;
}
