/* LELUYA - ZELENJAK program block */
/* calculation of the scaled dust absorption extinction coefficients */
/* the cross sections are already scaled by the q_abs(_1_) */

#include "ZELENJAK.h"

double q_abs (double x, double z, int lambda_i, int dust_component, int *err){
  /* 
  x, z     = coordinates of the point where we need q_abs
  lambda_i = lambda grid point
  dust_component = dust component for which we need q_abs
  err      = error flag
  */
  double density;  /* dust density at the point (x,z) */
  int err_density; /* error flag in search for the dust density */

  *err=0;
  if (lambda_i<0 || dust_component<0 || lambda_i>=lambda_Max ||
	dust_component>=Max_Dust_Type) {*err=1; return 0.0;}
  density = Dust_Density (x,z,dust_component,NULL,&err_density);
  if (err_density>0) {*err = err_density; return 0.0;}

  return (density*Sigma_Dust_Abs[dust_component][lambda_i]);

} /* end of the function 'q_abs' */
