/* LELUYA - ZELENJAK program block */
/* This function calculates the minimal grid cell size for a given distance
   from the center */

/* currently used: size_limit = CELL_SIZE_LIMIT*r */

#include "ZELENJAK.h"

double _ZELENJAK_size_limit(double x, double z) {

  /* the exponential radius dependence :
     _ZELENJAK_size_limit = limit1 * EXP( r * limit2)
  the following numbers will give:
    _ZELENJAK_size_limit(r=1)    =  CELL_SIZE_LIMIT 
    _ZELENJAK_minimal_tau_line(r=Rout) = Rout*CELL_SIZE_LIMIT  */

/*
  double limit2 = log(1.0/Rout)/(1.0-Rout);
  double limit1 = CELL_SIZE_LIMIT * exp(-limit2);
*/

  double r;
  double size_limit;

  r = sqrt(x*x+z*z);

  if (r<0.9) size_limit = 0.9*CELL_SIZE_LIMIT;

  /* CIT3_Finite_Cone03_Final model: */
  /* else if (r<1.6) size_limit = CELL_SIZE_LIMIT*0.333*r; */

  else if(INPUT.DUST_DENSITY_TYPE[0]==4) {
    /* Flared Disk model */ 
    /*else if (z>0.0815*pow((x-0.01),1.25)) size_limit = CELL_SIZE_LIMIT*r*0.5;  */
    /*else if (r<20 && z<0.5)  size_limit = CELL_SIZE_LIMIT*(r*0.5-0.25);        */
    /*else if (r<100 && z<5 && r>20) size_limit = CELL_SIZE_LIMIT*(r*1.125-12.5);*/
    if (r<10) size_limit = CELL_SIZE_LIMIT*r*0.5;
    else if (z<0.05*pow((x-0.01),1.25) && r<100) size_limit = CELL_SIZE_LIMIT*r*0.5;
    else size_limit = CELL_SIZE_LIMIT*r;
  }

  else if(INPUT.DUST_DENSITY_TYPE[0]==5) {
    /* Ohnaka model: */
    if (r<1.2) size_limit = CELL_SIZE_LIMIT*(r - 0.8);
    else size_limit = CELL_SIZE_LIMIT*r;
  }
  /* dafault */
  else size_limit = CELL_SIZE_LIMIT*r;

  return size_limit;

}
