/*********************** Algorithm flags *******************************/
/***** DEBUGGER FLAGS: */
#ifndef _DEBUGGER_FLAGS_

#define _DEBUGGER_FLAGS_
struct _Debugger_Flags {
  int SCREEN_MESSAGE;          /* -d : debug : run-time messages on the 
                                  screen about the program status */ 
  int STOP;                    /* -s n: stop : stop the running code at
                                  position specified by the number "n" */
  int CONTINUE;                /* -c n: continue : start the program at
                                  the point where it has been stopped by
                                  "-s n" flag */
  double NEW_POINT_X,NEW_POINT_Z;/* -c 206 flag: create a new grid point
                                  at (NEW_POINT_X,NEW_POINT_Z) at all
                                  wavelengths */
  double ADD_POINTS_R1, ADD_POINTS_R2; /* -c 210 flag: splits triangles along the
                                  azimuthal angle DEBUG.MAX_TRIANGLE_ANGLE radialy
                                  from DEBUG.ADD_POINTS_R1 to DEBUG.ADD_POINTS_R2 */
  double ISOTHERM_BENDING;    /* fixing the grid with smoothnes of the isotherms */
  double MAX_TRIANGLE_ANGLE;  /* fixing the grid by splitting cells with one of 
                                 its angles bigger than this (used for different 
			         purposes with different flags) */
  int AZIMUTHAL_GRID;         /* azimuthal triangular grid along concentric rings */
  double AZIMUTHAL_GRID1;     /* parameter sometimes used with AZIMUTHAL_GRID */
  int DENSITY_UPDATE;         /* -v flag: density update */
  double DENSITY_UPDATE_M, DENSITY_UPDATE_R; /* -v 1 flag: flared disk in vertical 
                                 hydrostatic equilibrium */
  int INPUT_DENSITY_UPDATE;   /* density update stored in the output/input files*/
  double INPUT_DENSITY_UPDATE_M, INPUT_DENSITY_UPDATE_R;
};

#endif

