/* 2D - Dusty:  global constants */

#ifndef _global_constants_

#define _global_constants_

#define TRUE  1
#define FALSE 0

#define PI 3.141592653589793

/* #define SQRT3 1.732050808 */

#define RAD1  0.01745329252

#define LIMIT_ON_THE_TOTAL_NUMBER_OF_VERTICES 20000 /* the total number of
                                       non-empty space vertices can not
                                       exceed this one */ 

#define _Temperature_Accuracy 0.01  /* accuracy in the search for a new 
                                       temperature
                                       used in _MATH_LIB_Ridder_Root */

#define _DUST_COMPONENT_NAME_SIZE_ 25/* length of a name of a dust component */

#define _DUST_DENSITY_TYPE_NAME_SIZE_  50  /* length of a name of a dust 
                                              density type*/

#define _SUBLIMATION_RADIUS_ACCURACY_ 0.05 /* accuracy of the initial 
                                       sublimation distances used in 
                                       _LEPAMARA_Find_Initial_Eta_Denominator */

#define _OPTICAL_DEPTH_LIMIT_ 10000.0 /* if the optical depth around a point
                                       is larger than this then do not
                                       put a grid point there */

#define _SUBLIMATION_TOLERANCE_ 0.001 /* accuracy of the sublimation 
                                        temperature */
#define _INITIAL_GRID_ARRAY_theta_min 0.0 
#define _INITIAL_GRID_ARRAY_theta_max (PI/2.0+1E-10)  /* min and max angle used in
                                        the initial grid array */
#define _INITIAL_GRID_ARRAY_min_temperature 1.0 /* minimal allowed for the
                                      initial temperature */

#define _MIN_VERTEX_DISTANCE_ 0.2  /* minimal distance between two vertices
                                      in the units of _PERUNIKA_size_limit. This
                                      is used in _PERUNIKA_clean_the_vertex_list */

#define MAX_NUMBER_OF_SPHERICAL_TRIANGLES 2000 /* maximum number of angular
                                   rays in the angular grid */ 

#define _GOROSTAS_N_phi_grid 32 /* angle to rotate vertices in 3D space for
                                  calculation of the angular grid. See:
                                  _GOROSTAS_create_integral_directions */

#define _T99999_  0.00001 /* temperature of (dust_type=99999) empty space */
#define _Density99999_ 1.0E-20 /* density of (dust_type=99999) empty space */
#define _Sigma99999_ 1.0E-20 /* dust cross section of empty space */

#endif
